<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               ref="crud"
               v-model="form"
               :permission="permissionList"
               :before-open="beforeOpen"
               :page.sync="page"
               @search-change="searchChange"
               @search-reset="searchReset"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getApiList, getApiLogs} from "@/api/logs";
  import {mapGetters} from "vuex";

  export default {
    data() {
      return {
        form: {},
        selectionList: [],
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        option: {
          height: 'auto',
          calcHeight: 30,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          editBtn: false,
          addBtn: false,
          delBtn: false,
          menuWidth: 120,
          dialogType: 'drawer',
          column: [
            {
              label: "服務id",
              prop: "serviceId",
              width:'120',
              hide: true,
            },
            {
              label: "服務host",
              prop: "serverHost",
              hide: true,
            },
            {
              label: "服務ip",
              prop: "serverIp",
              hide: true,
              width:'160'
            },
            {
              label: "軟件環境",
              prop: "env",
              width:'80',
              hide: true,
            },
            {
              label: "日志名",
              prop: "title",
              search: true,
            },
            {
              label: "請求方法",
              prop: "method",
              width:'80'
            },
            {
              label: "請求接口",
              prop: "requestUri"
            },
            {
              label: "日志時間",
              prop: "createTimeRange",
              search: true,
              hide: true,
              display: false,
              type: "datetime",
              format: "yyyy-MM-dd HH:mm",
              valueFormat: "yyyy-MM-dd HH:mm",
              searchRange:true,
            },
            {
              label: "日志時間",
              prop: "createTime",
              width:'180'
            },
            {
              label: "操作者",
              prop: "createBy",
              width:'180'
            },
            {
              label: "用戶代理",
              prop: "userAgent",
              span: 24,
              hide: true
            },
            {
              label: "請求數據",
              prop: "params",
              type: "textarea",
              span: 24,
              minRows: 2,
              hide: true
            }
          ]
        },
        data: []
      };
    },

    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          viewBtn: this.vaildData(this.permission.log_api_view, false)
        };
      }
    },
    methods: {
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {

        if (params.createTimeRange){
          params.createTime_begin = params.createTimeRange[0], params.createTime_end = params.createTimeRange[1];
          params.createTimeRange = null;
        }

        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getApiLogs(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getApiList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          data.records.forEach(item => {
            if (!item.createBy){
              //  tenantId=000000&username=mo153842&password=a5cfe98d240800a4e84eaa425abed1dd&grant_type=password&scope=all&type=account
              let arr = item.params.split('username=');
              if(arr.length > 1){
                item.createBy = arr[1].split('&')[0]
              }
            }
          })
          this.data = data.records;
          this.loading = false;
        });
      }
    }
  };
</script>

<style>
</style>
